var contextMenu = (function() {
    var contextMenuSetupFunc = null ;
    var contextMenuDiv = $( '#contextMenu' );
    var contextMenuButton = $( '#contextMenuButton' );
    
    var callbacks ;

    function clear() {
        contextMenuDiv.html('');
        callbacks = [];
    }
    
    function show() {
       contextMenuDiv.show();
       grayOutApp();
       
       
       $( 'body' ).click(  function(e) { hide() }  );
    }
    
    function isVisible() {
	     return contextMenuDiv.is(':visible')
    }

    function hide() {
        contextMenuDiv.hide();
        ungrayOutApp();
    }
    
    function pickContextMenu( index ) {
        callbacks[ index ]();
        hide();
    }
    
    
     function addMenuItem( text, enabled, callback ) {
           var menuItemDiv = document.createElement( 'div' );
           var menuIdx = callbacks.length ;
           if ( enabled ) {
           	  menuItemDiv.onclick = function() { pickContextMenu( menuIdx ); };
           }
           menuItemDiv.innerHTML = text ;
           menuItemDiv.className = 'menuItem ' + (enabled ? '' : 'disabledMenuItem');
           contextMenuDiv.append( menuItemDiv );
           callbacks[ callbacks.length ] = callback;
      }
	          
	          
      function initialize( event ) {
	      if ( contextMenuDiv.css( 'display' ) == 'block' ) {
	          hide();
	          return ;
	      }
          if ( contextMenuSetupFunc ) {
             hideMenu();
             killEvent( event );
             clear();
             contextMenuSetupFunc();
             show();
          }
          return false ;
      }
      	          
      	          
	function setSetupFunc( callback ) {
        contextMenuSetupFunc = callback ;
        if ( contextMenuSetupFunc == null ) {
             contextMenuButton.hide();
        }
        else {
             contextMenuButton.show();
        }
    }
    
          	          
    return {
          addMenuItem: addMenuItem,
	      
          setSetupFunc: setSetupFunc,
  
          initialize:  initialize,
          
          hide: hide,
          
          isVisible: isVisible
  	  	  
      } ;

})();

 