var dPad = function() {

    var dPadCenter = document.getElementById( 'dPadCenter' );
    var dPadUp = document.getElementById( 'dPadUp' );
    var dPadDown = document.getElementById( 'dPadDown' );
    var dPadRight = document.getElementById( 'dPadRight' );
    var dPadLeft = document.getElementById( 'dPadLeft' );
    var dPadArea = document.getElementById( 'dPadArea' );
    var dPadKeyListener = null ;
    var dPadKeys = [ { 'keyCode' : UP_ARROW_KEY,    'elem' : dPadUp },
                     { 'keyCode' : DOWN_ARROW_KEY,  'elem' : dPadDown },
                     { 'keyCode' : LEFT_ARROW_KEY,  'elem' : dPadLeft },
                     { 'keyCode' : RIGHT_ARROW_KEY, 'elem' : dPadRight } ];
    
    var startX ;
    var startY ;
    var changeX ;
    var changeY ;
    var bottom ;
    var left ;
    
    function dPadStartMove(event) {
        $('#dPadArea img').addClass('slightlyTransparent');
        $('#dPadArea img').removeClass('veryTransparent');
        var touchObj = event.changedTouches[0];
        startX = parseInt( touchObj.clientX );
        startY = parseInt( touchObj.clientY );
        changeX = changeY = 0;
        console.log( 'touchStart x=' + startX + ' y=' + startY );
        event.preventDefault();
        dPadCenter.addEventListener( 'touchmove', dPadMove, true );
        dPadCenter.addEventListener( 'touchend', dPadEndMove, true );
    } 
    
    
    
    function processAction( jqElement, keyCode ) {
        $('#dPadArea img').addClass('veryTransparent');
        $('#dPadArea img').removeClass('slightlyTransparent');
        jqElement.addClass('slightlyTransparent');
        jqElement.removeClass('veryTransparent');
        if ( dPadKeyListener ) {
        	dPadKeyListener( keyCode );
        }
    }
    
    function dPadArrowEnd( event ) {
        $('#dPadArea img').addClass('veryTransparent');
        $('#dPadArea img').removeClass('slightlyTransparent');
    } 
    
    function dPadMove( event ) {
        var touchObj = event.changedTouches[0];
        changeX = parseInt( touchObj.clientX ) - startX;
        changeY = parseInt( touchObj.clientY ) - startY;
        console.log( 'touchmove changeX=' + changeX + ' changeY=' + changeY );
        
        dPadArea.style.bottom = bottom - changeY ;
        dPadArea.style.left = left + changeX ;     
        event.preventDefault();     
    }
    
    function handleOrientationChange() {
    	var tmp = dPadArea.style.bottom ;
    	dPadArea.style.bottom = parseInt( dPadArea.style.left );
    	dPadArea.style.left = parseInt( tmp );
    	
    	tmp = bottom ;
    	bottom = left ;
    	left = tmp; 
    }
    
    function dPadEndMove(event) {
        console.log( 'touchend' );
        $('#dPadArea img').addClass('veryTransparent');
        $('#dPadArea img').removeClass('slightlyTransparent');
        bottom -= changeY ;
        left += changeX ;
        
        event.preventDefault();
        
        dPadCenter.removeEventListener( 'touchmove', dPadMove, true );     
        dPadCenter.removeEventListener( 'touchend', dPadEndMove, true );     
    }
    
    
    function show( listener ) {
        dPadKeyListener = listener ;
    	bottom = 20; 
    	left = 20; 
    	 
    	dPadArea.style.bottom = bottom ;
    	dPadArea.style.left = left ;
    	
        dPadCenter.addEventListener( 'touchstart', dPadStartMove );
        
    	dPadArea.addEventListener( 'touchstart', dPadAreaStartTouch );

        dPadUp.addEventListener( 'click', function() { console.log( 'UP' ); dPadKeyListener( UP_ARROW_KEY ); } );
        dPadDown.addEventListener( 'click', function() { console.log( 'DOWN' ); dPadKeyListener( DOWN_ARROW_KEY ); } );
        dPadLeft.addEventListener( 'click', function() { console.log( 'LEFT' ); dPadKeyListener( LEFT_ARROW_KEY ); } );
        dPadRight.addEventListener( 'click', function() { console.log( 'RIGHT' ); dPadKeyListener( RIGHT_ARROW_KEY ); } );
    	
    	dPadArea.style.display = 'block'; 
    }
    
    function dPadAreaStartTouch( event ) {
        console.log( 'dPadAreaStartTouch');
		previousDpadElement = null ;    	
        handleTouchingDpad( event );
    	dPadArea.addEventListener( 'touchend', dPadAreaEndTouch, true );
    	dPadArea.addEventListener( 'touchmove', dPadAreaMoveTouch, true );
    }
    
    function dPadAreaEndTouch( event ) {
        console.log( 'dPadAreaEndTouch');
    	dPadArea.removeEventListener( 'touchend', dPadAreaEndTouch, true );
    	dPadArea.removeEventListener( 'touchmove', dPadAreaMoveTouch, true );
    }
    
    function dPadAreaMoveTouch( event ) {
        console.log( 'dPadAreaMoveTouch');
        handleTouchingDpad( event );
        event.preventDefault();     
    }
    
    
    var previousDpadElement = null ;
    function handleTouchingDpad( event ) {
   	    var x = event.changedTouches[0].clientX ;
   	    var y = event.changedTouches[0].clientY ;
   	    console.log( 'handleTouchingDpad x=' + x + 'y=' + y );
   	    var element = document.elementFromPoint( x, y );
		console.log( 'touchOver ' + element.id );    	    
    	for ( var i=0; i<dPadKeys.length; i++ ) {
    	    var dPadKey = dPadKeys[i];
    	    if ( dPadKey.elem == element ) {
    	        if ( previousDpadElement != element ) { 
     				console.log( 'touchOver keyCode=' + dPadKey.keyCode );
     				processAction( $(element), dPadKey.keyCode );
     				previousDpadElement = element ;
     			}
     			return ;
     			    	    
    	    }
    	}
    }
    
    function hide() {
        dPadCenter.removeEventListener( 'touchstart', dPadStartMove );
        dPadArea.removeEventListener( 'touchstart', dPadAreaStartTouch );
        
    	dPadArea.style.display = 'none'; 
    }
    
    return {
        dPadEndMove: dPadEndMove,
        dPadStartMove: dPadStartMove,
        handleOrientationChange: handleOrientationChange, 
        hide: hide,
        show: show, 
    }
    
}();
