console.log( 'editset.js' );

var editPage = (function() {

	var stackName = $( '#stackName' );
	var sideLabels = $( '.labelRadio' );
	var createDataArea = $( '#createDataArea' );
	var currentCardId = null ;
    var numSides = 2;
    var chkPublic = document.getElementById( 'chkPublic' );
    var categorySelect = document.getElementById( 'category' );
    var currentSideId = -1;
    var isPro = false ;
    var maxValueLength ;
    var advancedOptions = $( '#advancedOptions' );
    var advancedOptionsToggler = $( '#advancedOptionsToggler' );

	stackName.change( function() {
	    studyStack.name = stackName.val();
  	    //setTitle( studyStack.name );
  	    refreshTitle();
	    dataManager.updateField( "studyStack", "name", studyStack.name, studyStack.id );
	    studyStack.markDirty(); 
	});
	
	var colorHtml = '' ;
	for ( var colorIndex=colorNames.length-1; colorIndex>0; colorIndex-- ) {
	    colorHtml += '<div class="colorChoice" id="color-' + colorIndex + '" onclick="editPage.setColor(' + colorIndex + ')" style="background-color:' + colorCodes[ colorIndex ] + '">' + colorNames[ colorIndex ] + '</div>' ;
	}
	var colorSelect = document.getElementById( 'stackColor' );
	colorSelect.innerHTML = colorHtml ;
	
	$('input[name=sideLabels]').change( onLabelChange );
	
	$( '#customLabels' ).click( function() {
	   $('input:radio[name="sideLabels"]').attr('checked', '');
	   $('#customLabelRadio' ).prop('checked','checked');
	   onLabelChange();
	} );
	
	$( '#qaLabel' ).click( function() {
	   $('input:radio[name="sideLabels"]').attr('checked', '');
	   $('#qaRadio' ).prop('checked','checked');
	   onLabelChange();
	} );
	
	$( '#termDefLabel' ).click( function() {
	   $('input:radio[name="sideLabels"]').attr('checked', '');
	   $('#termDefRadio' ).prop('checked','checked');
	   onLabelChange();
	} );
	
	advancedOptionsToggler.click( function() {
		  if ( advancedOptions.is(':visible') ) {
		      advancedOptions.hide();
		      advancedOptionsToggler.text( 'Advanced Options');
		  }
		  else {
			  advancedOptions.show();
		      advancedOptionsToggler.text( 'Hide Advanced Options');
		  }
	} );
	
    categorySelect.innerHTML = getCategoryOptionHtml() +
    		 '<option value="' + UNFINISHED_CATEGORY + '" >unfinished</option>' +
	         '<option value="' + HIDDEN_CATEGORY + '" >hidden</option>' +
             '<option value="' + PRIVATE_CATEGORY + '" >private</option>' ;
             
	categorySelect.onchange = onCategoryChange;

	
	function setColor( colorIndex ) {
	    studyStack.color = colorIndex ;
	    dataManager.updateField( "studyStack", "color", studyStack.color, studyStack.id );
	    $( ".colorChoice" ).css('border-color', '');
	    $( "#color-"+colorIndex ).css('border-color', 'blue');
	}

	function onCategoryChange() {
	    studyStack.category = categorySelect.value ;
	    if ( studyStack.category == PRIVATE_CATEGORY ) {
              chkPublic.checked = false ;
              categorySelect.disabled = true ;
	    }
	    
	    dataManager.updateField( "studyStack", "category", studyStack.category, studyStack.id );
	}
	
	function selectCard( cardId ) {
	    if ( currentCardId != null ) {
	         $( '#' + currentCardId  ).removeClass( 'currentCard' ); 
	    }
	    currentCardId = cardId ;
	     $( '#' + currentCardId  ).addClass( 'currentCard' ); 
	}
	
	var cardIdNum = 0;
	function createCardDiv() {
	     var cardDiv = document.createElement( 'div' );
	     cardDiv.className = 'editCard' ;
	     cardDiv.id = 'card' + cardIdNum ;
	     cardIdNum ++;
	     cardDiv.onclick = function() { selectCard( cardDiv.id ); }  ;
	     var cardNumber = document.createElement( 'div' );
	     cardNumber.innerHTML = cardIdNum ;
	     cardNumber.className = 'editCardNumber' ;
	     cardDiv.appendChild( cardNumber );
	     return cardDiv ;
	}
	
	function createAddCardDiv() {
		var addCardDiv = document.createElement( 'div' );
		addCardDiv.id = 'addCard' ;
		addCardDiv.onclick = addBlankRow;
		addCardDiv.innerHTML = "+<div id='addCardInstructions'>Add Card</div>" ;
		addCardDiv.className = 'editCard' ;
		return addCardDiv ;
	}
	
	
	var addCardDiv = null ;
	function populateDataCells() {
	    cardIdNum = 0;
	    createDataArea.html('');
	    var numCards = studyStack.rows.length ;
	    for ( var rowIndex = 0; rowIndex<numCards; rowIndex++ ) {
	         var row = studyStack.getRow( rowIndex );
	         var cardId = row.cardId;
	         var cardDiv = createCardDiv();
	         
	         var numFields = studyStack.getNumSides();
	         for ( var fieldIndex = 0; fieldIndex<numFields; fieldIndex++ ) {
	              var field = studyStack.fields[ fieldIndex ];
	              createDataEntryField( cardDiv, rowIndex, fieldIndex, row.getDataElement( field.id ).value );    
	         } 
	         createDataArea.append( cardDiv );
	    }
	    addCardDiv = createAddCardDiv();
	    createDataArea.append( addCardDiv );
        //addBlankRow();
	}
	
	function createDataEntryField( parentDiv, cardIndex, fieldIndex, dataValue ) {
		var label = document.createElement( 'label' );
		label.className = 'side' + fieldIndex + 'Label';
		label.innerHTML = studyStack.fields[ fieldIndex ].name ;
		parentDiv.appendChild( label );
		var textArea = document.createElement( 'textarea' );
		textArea.onchange = onDataChange;
		
		textArea.id = getTextAreaId( cardIndex, studyStack.fields[ fieldIndex ].id );
		$(textArea).text( dataValue );
		textArea.onfocus = onDataFocus;
		
		textArea.blur = onDataBlur;
        textArea.onkeyup = function() {checkLength( this );};
		checkLength( textArea );
		parentDiv.appendChild( textArea );
		
		var saving = document.createElement( 'div' );
		saving.innerHTML = 'saving' ;
		saving.id = getSavingId( textArea );
		saving.className = 'saving' ;
		parentDiv.appendChild( saving );
	}
	
	function getTextAreaId( cardIndex, fieldId ) {
	     return 'side.' + cardIndex + '.' + fieldId ;
	}
	
	function getSavingId( textArea ) {
		return 'saving_' + textArea.id ;
	}
	
	
	function createCardDivWithFields() {
         var cardDiv = createCardDiv();
         var numFields = studyStack.getNumSides();
         for ( var fieldIndex = 0; fieldIndex<numFields; fieldIndex++ ) {
              var field = studyStack.fields[ fieldIndex ];
              createDataEntryField( cardDiv, -1, fieldIndex, '' );    
         }
         return cardDiv ; 
	}
	
	function addBlankRow() {
         var blankRow = createCardDivWithFields() ;
         var createDataAreaElement = document.getElementById( 'createDataArea' );
         var val = createDataAreaElement.insertBefore( blankRow, addCardDiv );
         selectCard( blankRow.id )
         var firstTextArea = $( blankRow ).find( "textarea" )[0] ;
 		 $('#createsetPage').animate({
		    scrollTop: blankRow.offsetTop - 5
		 }, 300);         
         setTimeout( function() { firstTextArea.focus(); }, 350 );
	}
	
	
	
	function onDataChange( event ) {
		console.log( 'onDataChange' );
		var thisStack = studyStack ;
	    var textArea = event.target ;
	    showSaving( textArea );
	    checkLength( textArea );
	    var idParts = textArea.id.split( '.' );
	    var cardIndex = parseInt( idParts[1] );
	    var fieldId = parseInt( idParts[2] );
	    var row = (cardIndex<0) ? studyStack.getRowByCardId( -1 ) : studyStack.getRow( cardIndex );
	    var cardId = row.cardId;
	    if ( cardIndex < 0 ) {
	         var originalCardIndex = cardIndex ;
	         cardIndex = studyStack.rows.length - 1 ;
              // update textArea.id for all the fields of this card
	         var numFields = studyStack.getNumSides();
    	     for ( var fx = 0; fx<numFields; fx++ ) {
    	           var fId = studyStack.fields[fx].id;
    	           var originalId = getTextAreaId( originalCardIndex, fId ) ;
    	     	   var textArea2 = document.getElementById( originalId );
     	   		   var saving = document.getElementById( getSavingId( textArea2 ) );
    	     	   textArea2.id = getTextAreaId( cardIndex, fId );
    	     	   saving.id = getSavingId( textArea2 );
    	     }
	    }
	    
	    var dataElement = row.getDataElement( fieldId );
	    
	    dataElement.value = textArea.value ;
	    dataElement.dirty = 1;
	    dataManager.saveDataElement( studyStack.id, row.cardId, fieldId, dataElement,
	       function() {
	           thisStack.markDirty();
	           setTimeout( hideSaving, 200, textArea );
	       } 
	     );
	}
	
	function showSaving( textArea ) {
	    textArea.style.color = '#aaaaaa';
	    textArea.style.transition='';
		var saving = document.getElementById( getSavingId( textArea ) );
	    saving.style.transition='opacity 0.1s ease-in';
		saving.style.opacity = '1.0' ;
	}
	
	function hideSaving( textArea ) {
		console.log( 'hideSaving' + textArea.id );
	    textArea.style.transition='color 0.3s ease-out';
		textArea.style.color = '#000000';
		var saving = document.getElementById( getSavingId( textArea ) );
	    saving.style.transition='opacity 2.0s ease-out';
		saving.style.opacity = '0.0' ;
	}
	
	function onDataFocus( event ) {
	    var textArea = event.target ;
	    var cardDiv = textArea.parentNode ;
	    selectCard( cardDiv.id );
	    currentSideId = textArea.id.split( '.' )[2];
	    checkLength( textArea );
	}
	
	function onDataBlur( event ) {
	    var textArea = event.target ;
	    checkLength( textArea );
	}
	
	
	
   function textAreaLength( obj ) {
       var val = $(obj).val();

       var newLines = val.match(/(\r\n|\n|\r)/g);
       var addition = 0;
       if (newLines != null) {
           addition = newLines.length;
       }

       return val.length + addition;
   }

   function checkLength( obj ) {
       if ( textAreaLength( obj ) > maxValueLength ) {
           if ( !obj.tooLongWarning  ) {
               changeTooLongCounter( 1 );
           }
           obj.style.backgroundColor = '#ff0000';
           obj.tooLongWarning = true ;
           return false ;
       }
       else {
           if ( obj.tooLongWarning ) {
               changeTooLongCounter( -1 );
               obj.tooLongWarning = false ;
           }
           obj.style.backgroundColor = (obj.dirty) ? '#e0ede1' : '';
           return true ;
       }
   }
   
   function changeTooLongCounter( delta ) {
   }
	
	
	
	
	
	
	
	function onLabelChange() {
       studyStack.markDirty(); 
	   var value = $( 'input[name=sideLabels]:checked' ).val();
	   var sideLabels ;
	   if ( value == 'questionAnswer' ) {
	        sideLabels = [ 'Question', 'Answer' ];
	   }
	   else if ( value == 'termDefinition' ) {
	        sideLabels = [ 'Term', 'Definition' ];
	   }
	   else {
            sideLabels = [];
	        for ( var f=0; f<numSides; f++ ) {
	            var customLabelN = $( '#customLabel' + f ); 
	            customLabelN.removeAttr( "disabled" );
	            sideLabels[f] = customLabelN.val();
	        }
	   }
	   if ( value != 'custom' ) {
	        for ( var f=0; f<numSides; f++ ) {
	            var customLabelN = $( '#customLabel' + f ); 
	            customLabelN.attr( "disabled", "disabled" );
	        }
	   }
	   
	   for ( var f = 0; f<studyStack.getNumSides(); f++ ) {
		   if ( sideLabels[f] != studyStack.fields[f].name ) {
		        dataManager.updateField( 'studyfield', 'name', sideLabels[f], studyStack.fields[f].id );
		        studyStack.fields[f].name = sideLabels[f] ;
		   }
		   
		   $(".side" + f + "Label").each( function(index, item){
		         item.innerHTML = (sideLabels[f] == '') ? "&nbsp;" : sideLabels[f];
		   }) ;
	   }
	}



       var prevSelectedCategory = UNFINISHED_CATEGORY;
       
       function changePublic() {
        
         var categoryLabel = $( '#categoryLabel' ); 
         var jqCategorySelect = $( categorySelect );        
        
         if ( chkPublic.checked ) {
              categorySelect.disabled = false ;
              categoryLabel.removeClass( "disabledLabel" );
              categorySelect.value = prevSelectedCategory ;
              if ( categorySelect.value == PRIVATE_CATEGORY ) {
                  jqCategorySelect.val( UNFINISHED_CATEGORY ); 
                  
              }
         }
         else {
              prevSelectedCategory = categorySelect.value ;
              jqCategorySelect.val( PRIVATE_CATEGORY );
              categorySelect.disabled = true ;
              categoryLabel.addClass( "disabledLabel" );
         }
		 onCategoryChange();         
       }
       














	
	
	function insertCard() {
		toast( 'insertCard not yet implemented', 5000 );
/*	
	    var cardIndex = parseInt( currentCardId.substr( 4 ) );
	    var row = studyStack.getRow( cardIndex );
	    if ( row != null ) {
		    var curRowId = row.cardId; 
		    var prevRowId = 0;
		    if ( cardIndex > 0 ) {
		         prevRowId = studyStack.getRow( cardIndex - 1 ).cardId;
		    }
		    // give newly inserted card an id that is half way between the card before and the card after
		    var newCardId = (prevRowId + curRowId) / 2.0;
		    var newRow = studyStack.getRowByCardId( newCardId );
	        populateDataCells();
		}
*/				
	}
	
	
	function deleteCard() {
	    var cardIndex = parseInt( currentCardId.substr( 4 ) );
	    var row = studyStack.getRow( cardIndex );
        currentCardId = null ;
	    if ( row != null ) {
		    var cardId = row.cardId ;
		    dataManager.markForDeletion( studyStack.id, cardId, function() {
		         studyStack.deleteRow( cardId );
		         populateDataCells();
		    } );
		}
		else {
			populateDataCells();
		}
	}
	
	function deleteSide() {
	    toast( 'deleteSide not yet implemented currentSideId=' + currentSideId, 5000 );
	}
	
	function deleteSet() {
	    if ( "delete" == prompt( "Type delete if you really want to delete this set" ).trim().toLowerCase() ) {
	          dataManager.markSetForDeletion( studyStack.id, function () {
	              useStack( -1 );
	              clickMenuWithName( MY_SETS );
	          } ) ;
	    }
	}

        function resetPie() {
            if ( confirm( "Remove all pie pieces for this set?" ) ) {
                dataManager.updateField( "studystack", "finishedActivities", "", studyStack.id );
                studyStack.finishedActivities = '';
  	        refreshTitle();
                flashcardPage.clearState();
                hangmanPage.restartAll();
            }
        }
	
	function setupContextMenu() {
	    var cardNumber = '' ;
	    var currentCard = null ;
	    if ( currentCardId != null ) {
	    	currentCard = document.getElementById( currentCardId );
	    	if ( currentCard != null ) {
	    		cardNumber = currentCard.childNodes[0].innerHTML ;
	    	}
	    }
	    	
	    contextMenu.addMenuItem( "Insert Card ", currentCard != null, insertCard );
	    contextMenu.addMenuItem( "Delete Card " + cardNumber, currentCard != null, deleteCard );
	    //contextMenu.addMenuItem( "Delete Side...", studyStack.getNumSides() > 1, deleteSide );
	    contextMenu.addMenuItem( "Delete Set...", true, deleteSet );
            contextMenu.addMenuItem( "Reset Pie...", studyStack.finishedActivities.length > 0, resetPie );
	}

    function endPage() {
        console.log( 'editset.endPage calling syncService.start( false )' );
    	syncService.start( false );
    }
    
    function startCreateSetPage() {
  	    console.log( 'startCreateSetPage()' );
  	    currentCardId = null ;
	    var promise = dataManager.getNewStack();
	    promise.done( function( stack ) {
	         studyStack = stack ;
	         if ( stack ) {
	              currentStackId = stack.id ;
	              dataManager.setLocalItem( "currentStackId", currentStackId );
	              startEditSetPage();
	         }
	    } );
     }


   function addSide() {
       for ( var f=0; f<studyStack.getNumSides(); f++ ) {
            var customLabelN = $( '#customLabel' + f );
            if ( customLabelN != null ) {
                 customLabelN.val( studyStack.fields[f].name );
            }
        }
        
       var newStudyField = new StudyField( -1, '', -1, 1 ) ;
       dataManager.saveStudyField( studyStack.id, newStudyField, function() {
	       studyStack.fields[ studyStack.getNumSides() ] = newStudyField ;
	       populateSides();
		   $('input:radio[name="sideLabels"]').attr('checked', '');
    	   $('#customLabelRadio' ).prop('checked','checked');
	       populateDataCells();
	       $( '#customLabel' + (studyStack.getNumSides() - 1) ).focus();
       } );
   }	      
	      
    function populateSides() {
        var blankCustomSides = true ;
        var twoFields = (studyStack.getNumSides() == 2); 
	    if ( twoFields && studyStack.fields[0].name == 'Question' && studyStack.fields[1].name == 'Answer' ) {
	        $('#qaRadio').prop('checked',true);
	    }
	    else if ( twoFields && studyStack.fields[0].name == 'Term' && studyStack.fields[1].name == 'Definition' ) {
	        $('#termDefRadio').prop('checked',true);
	    }
	    else {
	        blankCustomSides = false ;
	        $('#customLabelRadio').prop('checked',true);
	    }

	    $('#qaRadio').attr('disabled', !twoFields );
	    $('#termDefRadio').attr('disabled', !twoFields );
	    
        var html = '' ;
	    if ( blankCustomSides ) {
			html = '<input type="text" id="customLabel0"/> / <input type="text" id="customLabel1"/>' ;
			numSides = 2;
	    }
	    else {
	         numSides = studyStack.getNumSides();
	         for ( var f=0; f<studyStack.getNumSides(); f++ ) {
	              if ( f > 0 ) {
	                   html += ' / ';
	              }
	              html += '<input type="text" id="customLabel' + f + '"/>';
	         }
	    }
	    html += "<a onclick='editPage.addSide()'>add&nbsp;side</a>" ;
	    
        $( '#customLabels' ).html( html );
        
        for ( var f=0; f<numSides; f++ ) {
            var customLabelN = $( '#customLabel' + f );
            if ( !blankCustomSides ) {
                 customLabelN.val( studyStack.fields[f].name );
            }
            customLabelN.change( onLabelChange );
        }

    }	      
	      
	      
    function startEditSetPage() {
        isPro = dataManager.getLocalItem( "pro" ) == 'true' ;
        maxValueLength = isPro ? 512 : 255;
	    //setTitle( studyStack.name );
	    refreshTitle();
		cardIdNum = 0;
	    currentCard = 0;
	    stackName.val( studyStack.name );
	    setColor( studyStack.color ) ;
	    $( colorSelect ).val( studyStack.color );
	    $( categorySelect ).val( studyStack.category ); 
	    
	    
        populateSides();		    
	    populateDataCells();
	    
	    onLabelChange();
	    contextMenu.setSetupFunc( setupContextMenu );
	    
        if ( categorySelect.value == PRIVATE_CATEGORY ) {
	           chkPublic.checked = false ;
	           categorySelect.disabled = true;
	    }
		else {
			chkPublic.checked = true;
			categorySelect.disabled = false ;
		}
	}	

		      
    return {
          addSide: addSide,
          changePublic: changePublic,
          endPage: endPage, 
          setColor: setColor,
          startCreateSetPage: startCreateSetPage,
          startEditSetPage: startEditSetPage,
      } ;

})();
