console.log( 'hangman.js' );

var hangmanPage = (function() {
    var letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    var punctuation = ".,|();: <>[]{}!@#$%^&*_-+=~`/?'";
    var word ;
    var hint ;
    var guessedLetters ;	
    var hangmanNumWrong ;
    var hangmanNumRight ;
    var hangmanGuessesDiv ;
    var hangmanImage = document.getElementById( 'hangmanImage' );
    //hangmanImage.onclick = showHint ;
    var hangmanPageDiv = document.getElementById( 'hangmanPage' );
    var numWins ;
    var hangmanHintShown = (dataManager.getLocalItem( "hangmanHintShown", "N" ) == "Y");
    
    
   var hintHelpTimer = null ;
   
   hangmanPageDiv.ontouchstart = hangmanPageDiv.onmousedown = function(event) {
        killEvent( event );
	    //showClue( hint );
	    showHint();
		if ( !hangmanHintShown ) {
			hintHelpTimer = setTimeout( disableShowingHintHelp, 2000 );
		}
   };
   
   hangmanPageDiv.ontouchend = hangmanPageDiv.onmouseup = function(event) {
	   if ( hintHelpTimer != null ) {
		   clearTimeout( hintHelpTimer );
		   hintHelpTimer = null ;
	   }
   }
   
   function disableShowingHintHelp() {
		dataManager.setLocalItem( "hangmanHintShown", 'Y' );
		hangmanHintShown = true ;
   }
   
   hangmanPageDiv.ontouchend = hangmanPageDiv.onmouseup = function( event ) {
        killEvent( event );
	    hideClue( hint );
   };

	function startPage() {
       hintOverKeyboard.style.top = '10%';
       hintOverKeyboard.style.bottom = 'auto';

	   sharePath = '/hangman-' + studyStack.idOnStudyStack ;
	   numWins = 0;
	   showKeyboard();
	   document.onkeypress = handleKeyPress ;
	   
	   document.getElementById( 'wrap3' ).className = '' ;
	   hangmanGuessesDiv = document.getElementById( 'hangmanGuesses' );
	   console.log( 'hangmanPage.startPage studyStack.id = ' + studyStack.id );
	   dataManager.markMostRecentlyUsed( studyStack );
	   
       contextMenu.setSetupFunc( setupContextMenu );
       
       var savedSessionData = dataManager.getLocalItem( getStateVarName( studyStack.id ) );
       if (  savedSessionData != null && savedSessionData.length > 10 ) {
          console.log( 'savedSessionData.length=' + savedSessionData.length ) ;
          restoreState( savedSessionData );
          updateGuess();
       }
       else {
           gameWords = null ;
           playAgain();
       }
	}
	
	function getStateVarName( stackId ) {
		return 'hmstate' + stackId ;
	}
	function restoreState( savedSessionData ) {
		var savedParts = savedSessionData.split( '|' );
		numWins = parseInt( savedParts[0] );
		word = savedParts[1];
		hint = savedParts[2];
		var lettersPressed = savedParts[3];
		hangmanNumRight = parseInt( savedParts[4] );
		
		guessedLetters = '' ;
		hangmanNumWrong = 0;
		for (var i = 0, len = lettersPressed.length; i < len; i++) {
			  processLetter( lettersPressed[i] );
		}
	}
	
	function saveState() {
		var state = numWins + '|'
	        + word + '|' 
	        + hint + '|'
	        + guessedLetters + '|'	
	        + hangmanNumRight ;
        dataManager.setLocalItem( getStateVarName( studyStack.id ), state );
	}
	
	function handleKeyPress(evt) {
//	    console.log( 'hangman handleKeyPress' );
            

  		evt = evt || window.event;
	    var charCode = evt.which || evt.keyCode;
        var charStr = String.fromCharCode(charCode);
        if ( charStr.length == 1 ) {
             var letter = charStr.toUpperCase() ;
             var obj = document.getElementById( "kbd-" + letter );
             if ( obj != null ) { 
                 pressKey( obj, letter );
             }
        }
    }
	
	
	function pressKey( obj, letter, event ) {
		killEvent( event );
		vibrate(15);
		processLetter( letter );
        saveState();
	}
	
	
   function processLetter( letter ) {
	    var obj = document.getElementById( 'kbd-' + letter ); 
	    if ( obj == null ) {
	    	return ;
	    }
//	    console.log( 'processLetter' + letter + ' obj=' + obj );
		obj.onclick = null ;
		obj.ontouchstart = null ;
		obj.className = 'usedKey' ; 
        if ( guessedLetters.indexOf( letter ) >= 0 ) {
                return ;
        }
        guessedLetters += letter ;

        if ( word.indexOf( letter ) < 0 ) {
            if ( hangmanNumWrong < 6 ) {
                hangmanNumWrong ++ ;
                setHangManImage( hangmanNumWrong  );
                if ( hangmanNumWrong == 6 ) {
                    setTimeout( hangmanPage.youLose, 500 );
                }
                else if ( hangmanNumWrong == 5 && !hangmanHintShown ) {
                     toast( 'Press the hang man to display a hint', 4000 );
                }
            }
        }
        else {
            updateGuess(); 
            if ( hangmanNumRight == word.length ) {
                youWin();
            }
        }
     }

     function updateGuess() {
          hangmanGuessesDiv.innerHTML = getCurrentGuess();
     }

     function getCurrentGuess() {
          var guess = '' ;
          hangmanNumRight = 0;
          for ( var i=0; i<word.length; i++ ) {
               var letter = word.charAt( i );
               if ( letters.indexOf( letter ) < 0 ) {
                     guess += letter;
                     hangmanNumRight ++ ;
               }
               else if ( guessedLetters.indexOf( letter ) >= 0) {
                     guess += letter ;
                     hangmanNumRight ++ ;
               }
               else {
                     guess += '_' ;
               }
          }
          return  guess ;
     }     
     
   
   
     
     
     function setHangManImage( imageNumber ) {
//    	console.log( 'setHangManImage ' + imageNumber );
		var canvas = document.getElementById('hangmanImage');
		var context = canvas.getContext('2d');
		
		context.clearRect(0, 0, canvas.width, canvas.height);
		 
		var centerX = canvas.width / 2;
		var centerY = canvas.height / 2;
		var radius = canvas.height / 9;
		var bottom = canvas.height * 0.95;
		var top = 3;
		
		context.beginPath();
		context.lineWidth = 4;
		context.strokeStyle = '#00796b';
		 
		context.moveTo(0,bottom);
		context.lineTo(canvas.width,bottom);
		var x = canvas.width * 0.15 ;
		context.moveTo( x, bottom );
		context.lineTo( x, top );
		x = canvas.width * 0.6 ;
		context.lineTo( x, top );
		context.lineTo( x, canvas.height * 0.10 );
		context.stroke();
		
		
		var dy = (imageNumber < 8) ? 0 :canvas.height * 0.15 ;

		if ( imageNumber > 0 ) {
			// head
			context.beginPath();
			context.arc(x, canvas.height * 0.22 + dy, radius, 0, 2 * Math.PI, false);    
			context.stroke();
		}
		
		context.beginPath();
		if ( imageNumber > 1 ) {
			//body
			context.moveTo( x, canvas.height * 0.34 + dy );
			context.lineTo( x, canvas.height * 0.55 + dy );
		}
		
		// arms
		var w = canvas.width / 5;
		if ( imageNumber > 2 ) {
			context.moveTo( x, canvas.height * 0.4 + dy );
			context.lineTo( x-w, canvas.height * 0.5 + dy);
		}
		if ( imageNumber > 3 ) {
			context.moveTo( x, canvas.height * 0.4 + dy);
			context.lineTo( x+w, canvas.height * 0.5 + dy);
		}
		
		// legs
		w = canvas.width / 7;
		if ( imageNumber > 4 ) {
			context.moveTo( x, canvas.height * 0.55 + dy);
			context.lineTo( x-w, canvas.height * 0.8 + dy);
		}
		if ( imageNumber > 5 ) {
			context.moveTo( x, canvas.height * 0.55 + dy );
			context.lineTo( x+w, canvas.height * 0.8 + dy);
		}
		context.stroke();
		context.lineWidth = 2;

		
		if ( imageNumber == 8 ) {
			//   o o  eyes
			context.beginPath();
			context.arc( x-radius/3, canvas.height * 0.2 + dy, radius/4, 0, 2*Math.PI, false );
			context.stroke();
			
			context.beginPath();
			context.arc( x+radius/3, canvas.height * 0.2 + dy, radius/4, 0, 2*Math.PI, false );
			context.stroke();

			// smile
			context.beginPath();
			context.arc(x, canvas.height * 0.18 + dy, radius, Math.PI*0.3,  0.7*Math.PI, false);    
			context.stroke();
		}
		
		if ( imageNumber == 7 ) {
			//   x x  eyes
			w = radius / 5;
			var d = w*1.6 ;
			var y = canvas.height * 0.2 + dy;
			context.moveTo( x-w, y );
			context.lineTo( x-w-d, y-d );
			context.moveTo( x-w, y-d );
			context.lineTo( x-w-d, y );
			
			context.moveTo( x+w, y );
			context.lineTo( x+w+d, y-d );
			context.moveTo( x+w, y-d );
			context.lineTo( x+w+d, y );
			
			context.stroke();

			// frown
			w = radius/2;
			y = canvas.height * 0.275 + dy ;
			context.moveTo( x-w, y );
			context.lineTo( x+w, y );
			context.stroke();
		}
		
		

     }
     



     function youLose() {
        updateScore( false );
        setHangManImage( 7 );
        showHint();
        setTimeout( function() { hangmanPage.showAnswer( 0 ); }, 600 );
     }

     function showAnswer( pos )
     {
        while ( pos<word.length )
        {
             letter = word.charAt( pos );
             pos++;
             if ( guessedLetters.indexOf( letter ) < 0 ) {
			        guessedLetters += letter ;
    		        updateGuess(); 
                    setTimeout( function() { hangmanPage.showAnswer( pos ); }, 300 );
                    return ;
             }
        }
        showPlayAgain();
     }



     function youWin()  {
        updateScore( true );
        setHangManImage( 8 );
        showHint();
        //youWonDiv.style.display='block';
        showPlayAgain();
        numWins++;
        if ( numWins > 7 ) {
            studyStack.finishActivity( HANGMAN_CODE );
        }
     }
     
     function showPlayAgain() {
     	var html = "<div id='hangmanPlayAgain'>" +
                    "<button id='hangmanPlayAgainButton' onclick='hangmanPage.playAgain()'>Play Again</button>" +
                "</div>" ;
    	keyboardArea.innerHTML = html ;
        document.getElementById( "hangmanPlayAgainButton" ).focus();
  	}
     
     
     
     function updateScore( won ) {
     }


    function restartAll() {
           dataManager.setLocalItem( getStateVarName( studyStack.id ), '' );
     }


    
	function playAgain() {
	   hideClue();
	   hintOverKeyboard.onclick = null;
       var wordAndHint = getNextWord();
       if ( wordAndHint == null ) {
    	   toast( 'There are not enough words in your cards for hangman', 4000 );
    	   keyboardArea.style.display = 'none';
    	   word = '' ;
    	   hint = '' ;
       }
       else {
           word = wordAndHint.word.toUpperCase() ;
           hint = wordAndHint.hint ;
    	   showKeyboard();
       }
       guessedLetters = '' ;
       hangmanNumWrong = 0;
       setHangManImage( hangmanNumWrong );
       hangmanNumRight = 0;
       setTimeout( hangmanPage.updateGuess, 50 );
	}
	
	function setupContextMenu() {
//	    contextMenu.addMenuItem( "Show Hint", true, showHint );
	    contextMenu.addMenuItem( "Give Up", true, giveUp );
	}

    function showHint() {
		showClue( escapeHtml(hint) );
		hintOverKeyboard.onclick = hideClue ;
    }
    
    function giveUp() {
         youLose();    
    }
    
    
    
    function numLetters( word ) {
        var count = 0;
        word = word.toUpperCase();

        for ( var i=0; i<word.length; i++ ) {
            var letter = word.charAt( i );

            if ( letters.indexOf( letter ) >=0 ) {
                count ++;
            }
        }
        return count ;
    }
    
    function uniqueLetters( word ) {
        var count = 0;
        word = word.toUpperCase();
        for ( var i=0; i<letters.length; i++ ) {
           var letter = letters.charAt( i );
           
           if ( word.indexOf( letter ) >= 0 ) {
               count ++ ;
           }
        }
        return count ;
    }
    
    
    var gameWords ;
    
    function getNextWord() {
        if ( gameWords == null ) {
            gameWords = [];
        }
        if ( gameWords.length == 0 ) {
              studyStack.loadWords( 8, 20, { addWord: function( word, hint ) {
                   if ( numLetters( word ) <= 5 || uniqueLetters( word ) > 14 ) {
                       return false ;
                   }
                   gameWords[ gameWords.length ] = { word: word, hint: hint };
                   return true;
              } } ) ;
              shuffle( gameWords );
        }
        if ( gameWords.length == 0 ) {
             //return { hint: 'Under', word: 'Construction'};
        	return null ;
        }
        return gameWords.splice( 0, 1 )[0];
    }	
	
    function writeKeyboardRow( letters ) {
	      var html = "" ;
	      for ( var i=0; i<letters.length; i++ ) {
	          var letter = letters.charAt( i );
	          html += "<td id='kbd-" + letter + "' colspan='3' " + 
	                  "onclick='hangmanPage.pressKey( this, \"" + letter + "\", event )'"  +
                          "ontouchstart='hangmanPage.pressKey( this, \"" + letter + "\", event )'" +
                           " >" + letter + "</td>" ;
	      }
	      if ( letters.charAt( 0 ) == "A" ) {
	          html = "<td colspan='1' class='blankKey'></td>" +
	                 html +
	                 "<td colspan='1' class='blankKey'></td>" ;
	      }
	      else if ( letters.charAt( 0 ) == "Z" ) {
	          html = "<td colspan='2' class='blankKey'></td>" +
	                 html ;
	                 //"<td colspan='7' class='hintKey' id='hintKey'>hint</td>" ;
	      }
	      
	      
	      
	      html = "<tr>" + html + "</tr>" ;
	      return html ;
	}
	  
	function showKeyboard() {
	    var html = '' ;
	    html += "<table id='keyboard'>" ;
	    html += writeKeyboardRow( "QWERTYUIOP" );
	    html += writeKeyboardRow( "ASDFGHJKL" );
	    html += writeKeyboardRow( "ZXCVBNM" );
	    html += "</table>" ;
	    keyboardArea.innerHTML = html ;
        keyboardArea.style.display = 'block';
	}
	
	
	
    return {
          startPage: startPage,
          pressKey: pressKey,
          updateGuess: updateGuess,
          youLose: youLose,
          showAnswer: showAnswer,
          playAgain: playAgain,
          restartAll: restartAll
      } ;

})();

	
