console.log( 'main.js' );

 //localStorage.clear();  // DELETE THIS LINE
  
  var menuArea = document.getElementById( 'menuArea' );
  var grayOutBackgournd = document.getElementById( 'grayOutBackground' );
  var keyboardArea = document.getElementById( 'keyboardArea' );
  var hintOverKeyboard = document.getElementById( 'hintOverKeyboard' );
  var titleArea = document.getElementById( 'titleArea' );

  var MY_SETS = "My Sets";
  var CREATE_NEW_SET = "Create new set" ;
  var EDIT_THIS_SET = "Edit this set" ;
  var SEARCH_STUDYSTACK = "Search online sets" ;
   
  var FLASHCARD_ACTIVITY = "Flashcards" ;
  var HANGMAN_ACTIVITY = "Hangman" ;
  var HUNGRY_BUG_ACTIVITY = "Hungry Bug" ;
  var MATCHING_ACTIVITY = "Matching" ;
  var CROSSWORD_ACTIVITY = "Crossword" ;
  var QUIZ_ACTIVITY = "Quiz" ;

  var FLASHCARD_CODE = 'F';
  var HANGMAN_CODE = 'H';
  var MATCHING_CODE = 'M' ;
  var QUIZ_CODE = 'Q';
  var CROSSWORD_CODE = 'C' ;
  var HUNGRYBUG_CODE = 'S';  // snake
  

  var NUM_STUDY_ACTIVITIES = 6 ;
  var menuItems = [ { "type" : "HEADING", "name" : "ACTIVITIES" },
                    { "type" : "ITEM",    "name" : FLASHCARD_ACTIVITY,      "page" : "flashcardsPage", "pieColor" : "#ff0000", "onStart" : flashcardPage.startPage, "onEnd" : flashcardPage.endPage,    "enableFunc" : needsStack,  "onOrientationChange" : flashcardPage.onOrientationChange, "pieCode" : FLASHCARD_CODE},
                    { "type" : "ITEM",    "name" : HANGMAN_ACTIVITY,        "page" : "hangmanPage",    "pieColor" : "#FFF200", "onStart" : hangmanPage.startPage,      "enableFunc" : needsStack, "pieCode" : HANGMAN_CODE }, 
                    { "type" : "ITEM",    "name" : HUNGRY_BUG_ACTIVITY,     "page" : "hungryBugPage",  "pieColor" : "rgb(171, 232, 155)", "onStart" : hungryBugPage.startPage,    "onEnd": hungryBugPage.endPage, "enableFunc" : needsStack, "pieCode" : HUNGRYBUG_CODE, "pausePage" : hungryBugPage.pausePage, "resumePage" : hungryBugPage.resumePage },
                    { "type" : "ITEM",    "name" : MATCHING_ACTIVITY,       "page" : "matchingPage",   "pieColor" : "#00A2E8", "onStart" : matchingPage.startPage,     "enableFunc" : needsStack, "onOrientationChange" : matchingPage.onOrientationChange, "pieCode" : MATCHING_CODE }, 
                    { "type" : "ITEM",    "name" : CROSSWORD_ACTIVITY,      "page" : "crosswordPage",  "pieColor" : "#FF7F27", "onStart" : crosswordPage.startPage,    "enableFunc" : needsStack, "pieCode" : CROSSWORD_CODE }, 
                    { "type" : "ITEM",    "name" : QUIZ_ACTIVITY,           "page" : "quizPage",       "pieColor" : "#A349A4", "onStart" : quizPage.startPage,         "enableFunc" : needsStack, "pieCode" : QUIZ_CODE },
                    { "type" : "HEADING", "name" : "TOOLS" }, 
                    { "type" : "ITEM",    "name" : CREATE_NEW_SET,          "page" : "createsetPage", "onStart" : editPage.startCreateSetPage, "onEnd" : editPage.endPage, "enableFunc" : false },
                    { "type" : "ITEM",    "name" : EDIT_THIS_SET,           "page" : "createsetPage", "onStart" : editPage.startEditSetPage,   "onEnd" : editPage.endPage, "enableFunc" : needsRealStack },
                    { "type" : "ITEM",    "name" :  MY_SETS,                "page" : "mysetsPage",    "onStart" : mysetsPage.startPage,                                    "enableFunc" : false },
                    { "type" : "ITEM",    "name" : SEARCH_STUDYSTACK, "page" : "searchPage",    "onStart" : searchPage.startPage,                                    "enableFunc" : hasNetworkConnection },
                    ];

function pieMessage( pieCode ) {
   switch ( pieCode ) {
       case FLASHCARD_CODE: return 'Get all the flashcards into the "Know" box' ;
       case HANGMAN_CODE:   return "Solve seven hangman puzzles" ;
       case MATCHING_CODE:  return "Match all " + studyStack.numCards + " " + studyStack.fields[0].name + "/" + studyStack.fields[1].name + " pairs ";
       case QUIZ_CODE:      return "Score 80% or higher on this quiz" ;
       case CROSSWORD_CODE: return "Solve this crossword puzzle" ;
       case HUNGRYBUG_CODE:  return "Grow your bug to 15 segments" ;
    }
    return "?" ;
}

// the following three arrays should be in the same order 
var ACTIVITY_CODES = [ FLASHCARD_CODE, MATCHING_CODE, HANGMAN_CODE, HUNGRYBUG_CODE, CROSSWORD_CODE, QUIZ_CODE ];
var ACTIVITY_NAMES = [ FLASHCARD_ACTIVITY, MATCHING_ACTIVITY, HANGMAN_ACTIVITY, HUNGRY_BUG_ACTIVITY,CROSSWORD_ACTIVITY, QUIZ_ACTIVITY ];


function pieImage( code ) {
    var i=0;
    for ( i=0; i<ACTIVITY_CODES.length; i++ ) {
        if ( ACTIVITY_CODES[i] == code ) {
            return "images/pie" + (i+1) + ".png" ;
        }
    }
    return "" ;
}

function pieHtml( stack ) {
     var html = "<div class='pieHolder' onclick='onPieClicked(" + stack.id + ", event)'><img src='images/pie.png' />"; 
     for ( var i=0; i<ACTIVITY_CODES.length; i++ ) {
         var code = ACTIVITY_CODES[i];
         if ( stack.hasFinishedActivity( code ) ) {
             html += "<img src='images/pie" + (i+1) + ".png' />" ;
         }
     }
     html += "</div>" ;
     return html ;
 }

function onPieClicked( stackId, event ) {
	
     killEvent( event );
     
     if ( selectedMenuItemIndex >= 0 && menuItems[ selectedMenuItemIndex ].pieCode && studyStack != null) {
         var pieCode = menuItems[ selectedMenuItemIndex ].pieCode ;
         if ( studyStack.hasFinishedActivity( pieCode ) ) {
              toast( "You've already earned the pie piece for this activity.", 3000 );
         }
         else {
              toast( pieMessage( pieCode ) + " to get the pie piece for this activity.", 4000 );
         }
     }
     else if ( studyStack != null && studyStack.id == stackId ) {
          nextActivityForStack( studyStack );
     }
     else {
          dataManager.getStack( stackId, nextActivityForStack ) ;
     }
     logDebugInfo();     
}

function nextActivityForStack( stack ) {
    studyStack = stack ;
    for ( var i=0; i<ACTIVITY_CODES.length; i++ ) {
         var code = ACTIVITY_CODES[i];
         if ( !stack.hasFinishedActivity( code ) ) {
              clickMenuWithName( ACTIVITY_NAMES[i] );
              return ;
         }
    }
}



  function toggleMenu( event ) {
  	  if ( isMenuDisplayed() ) {
  	      hideMenu();
  	  }
  	  else {
  	      showMenu( event );
  	  }
  }
  
  function showMenu( event ) {
      contextMenu.hide();
      killEvent( event );
  
      initMenu();
      grayOutApp();
      menuArea.style.display = 'block';
      setTimeout( function() {
          menuArea.style.left = '0px';
      }, 0 );
  }
  
  function hideMenu() {
     console.log( 'hideMenu()' );
     ungrayOutApp();
     var menuWidth = $( menuArea ).width();
     if ( menuWidth == 0 ) {
          menuWidth = 100;
     }
     menuArea.style.left = -menuWidth + 'px';
     setTimeout( function() { menuArea.style.display = 'none'; }, 300 );
  }
  
  
  function selectedMenuItem() {
      if ( selectedMenuItemIndex >= 0 ) {
  	  	   return menuItems[ selectedMenuItemIndex ] ;
  	  }
  	  else {
  	       return null ;
  	  }
  }
  
  function grayOutApp() {
      if ( grayOutBackground.style.display != 'block' ) {
	      var menuItem = selectedMenuItem() ;
	      if ( menuItem && menuItem.pausePage ) {
	          menuItem.pausePage();
	      }
	      grayOutBackground.style.display = 'block';
	 }
  }
  
  function ungrayOutApp() {
      if ( grayOutBackground.style.display != 'none' ) {
	      grayOutBackground.style.display = 'none';
	      var menuItem = selectedMenuItem() ;
	      if ( menuItem && menuItem.resumePage ) {
	          menuItem.resumePage();
	      }
	  }
  }
  
  function isMenuDisplayed() {
      var retVal = (menuArea.style.display == 'block') && (menuArea.style.left == '0px') ;
      console.log( 'isMenuDisplayed returning ' + retVal );
      return retVal ;
  }
             
  grayOutBackground.onclick = hideMenu ;       
      
  function needsStack() {
       return (studyStack != null) && (studyStack.getNumCards() > 0); 
  }
  
  function needsRealStack() {
      return studyStack != null && studyStack.id >= 0 ;
  }
 
  function getMenuItemHtml( menuItem, index ) {
         if ( menuItem.type == "HEADING"  ) {
             return "<div class='menuTitle'>" + menuItem.name + "</div>" ;
         }
         else {
             var className = "menuItem" ;
             var clickAttr = "" ;
             var completed = "" ;
             if ( menuItem.enableFunc && !menuItem.enableFunc() ) {
                 className += " disabledMenuItem" ;
             }
             else {
                  clickAttr = " onclick='clickMenu(" + index + ")'" ; 
                  if ( index==selectedMenuItemIndex ) {
                      className += " selectedMenuItem" ;
                  }
                  var pieCode = menuItems[ index ].pieCode ;
                  if ( pieCode && studyStack.hasFinishedActivity( pieCode ) ) {
                	  var pieColor = menuItems[ index ].pieColor ;
                	  completed = "<div class='completedPieMarker'>" + svgPieSlice( pieColor ) + "</div>" ;
                  }
             }
             return "<div  class='" + className + "'" + clickAttr + ">" + menuItem.name +
                        completed +
                    "</div>" ;
         }
  }
     
  
  function addRecentSet( stack ) {
      console.log( 'got stack ' + stack );
      if ( recentStacksArea.innerHTML.length < 5 ) {
           recentStacksArea.innerHTML = "<div class='menuTitle'>RECENTLY STUDIED</div>" ;
      }
      console.log( 'in getRecentStacks currentStackId=' + currentStackId );
      var classNames = "menuItem" + ((stack.id == currentStackId ) ? " selectedStack" : "" );
      var stackName = ( stack.name.trim().length == 0 ) ? "(untitled)" : stack.name ;
      recentStacksArea.innerHTML += "<div class='" + classNames + "' onclick='useStack(" + stack.id + ")'>" + escapeHtml(stackName) + "</div>" ;
  }
  
  function initMenu() {
     var menu = '' ;
     for ( var i=0; i<menuItems.length; i++ ) {
         var menuItem = menuItems[i] ;
         menu += getMenuItemHtml( menuItem, i );
     }

     menuArea.innerHTML = "<div id='recentStacksArea'></div>" + menu ;
     var recentStacksArea = document.getElementById( 'recentStacksArea');

     console.log( 'calling getRecentStacks' );
     dataManager.getRecentStacks( 3, addRecentSet );
  }
  
  

  function findMenuWithName( name ) {
     for ( var i=0; i<menuItems.length; i++ ) {
         var menuItem = menuItems[i] ;
         if ( menuItem.name == name ) {
             return i;
         }
     }
     return -1;
  }
  
  
  function clickMenuWithName( name ) {
      clickMenu( findMenuWithName( name ) );
  }


  var firstMenuClick = true ;
  
  function clickMenu( index ) {
     console.log( 'clickMenu ' + index );
     hideMenu();
     contextMenu.hide();
     if ( !firstMenuClick && index==selectedMenuItemIndex ) {
         return ;
     }
     firstMenuClick = false ;

     if ( selectedMenuItemIndex && selectedMenuItemIndex >= 0 ) {
          leaveMenuItem( menuItems[ selectedMenuItemIndex ] ); 
     }
     
     dataManager.setLocalItem( 'selectedMenuItemIndex', '' + index );
     selectedMenuItemIndex = index ;
     if ( index <= NUM_STUDY_ACTIVITIES ) {
         dataManager.setLocalItem( 'selectedStudyActivity', index );
         selectedStudyActivity = index ;
     }
     
     
     var menuItem = menuItems[index];
     if ( menuItem.page ) {
          keyboardArea.style.display = 'none';
          document.getElementById( 'wrap3' ).className = 'wrap3' ;
          
           $(".page").each( function(index, item){
                  console.log( 'hiding ' + item.id );
           	      item.style.display = 'none';
            }) ;
           var page = $( "#" + menuItem.page );
           console.log( 'showing ' + menuItem.page );
           
           resetPage();           
           page.show();
           if ( menuItem.onStart ) {
                menuItem.onStart();
           }
     }
  }

  function leaveMenuItem( menuItem ) {
      if ( menuItem.page ) {
          if ( menuItem.onEnd ) {
              menuItem.onEnd() ;
          }
      }
  } 
  

  function resetPage() {
     if ( studyStack != null ) {
     	   refreshTitle();
     }
     contextMenu.setSetupFunc( null );
     document.onkeydown = null ;
     document.onkeypress = null ;
     dataManager.setChangeListener( mysetsPage );
     hideClue()
  }  

  function editStack( id ) {
      useStack( id, findMenuWithName( EDIT_THIS_SET ) );
  }
  
  function useStack( id, activity ) {
       contextMenu.hide();
       if ( !activity ) {
           activity = selectedStudyActivity ;
           selectedMenuItemIndex = null ;
       }
       console.log( 'useStack activity=' + activity + ' selectedStudyActivity = ' + selectedStudyActivity );
       setTitle( '' ); 
       studyStack = null ;
       console.log( 'useStack setting currentStackId to ' + id );
       dataManager.setLocalItem( "currentStackId", id );
       currentStackId = id ;
       dataManager.getStack( currentStackId, function( stack ) {
           console.log( 'getStack called back with stack=' + stack );
           console.log( 'stack=' + JSON.stringify( stack ) );
           if ( stack != null ) {
           	   studyStack = stack ;
               refreshTitle();
           	   
               console.log( 'studyStack.name = ' + studyStack.name );
               if ( stack.numCards == 0 ) {
                   clickMenuWithName( EDIT_THIS_SET );
               }
               else { 
               	   clickMenu( activity );
               }
           }
       } );
  }

  function setTitle( title ) {
   	  titleArea.style.display = 'block' ;
      titleArea.innerHTML = title ;
  }
  
  function refreshTitle() {
       setTitle( "<span onclick='clickMenuWithName( MY_SETS )'>" + studyStack.name + "</span>" + pieHtml( studyStack ) );
  }
       
  function showClue( clue ) {
  	  hintOverKeyboard.innerHTML = clue ;
   	  hintOverKeyboard.style.display = 'block';
  }
  
  function hideClue() {
      hintOverKeyboard.style.display = 'none';  
  }
        
  function initializeApplication() {
       console.log( 'initializeApplication' );

       if (typeof StatusBar !== 'undefined') {
        	StatusBar.hide();
       }
       
       
       
       dataManager.initializeDatabase( function( success ) {
    	  console.log( 'in initializeDatabase success callback.   navigator=' + navigator );       
          if ( navigator && navigator.splashscreen ) {
               console.log( 'hiding splashscreen' );
		       navigator.splashscreen.hide() ;
		  }
		         
          if ( !success ) {
          	   toast( 'Failed to create database :-(', 10000 );
          }
          else {
	           initializationComplete = true ;
     	       window.addEventListener( 'orientationchange', handleOrientationChange );

	           currentStackId = dataManager.getLocalItem( "currentStackId", -1 );
	           console.log( 'currentStackId=' + currentStackId + ' openUrl=' + window.openUrl );
	           if ( currentStackId != null && currentStackId>=0 && window.openUrl == null ) {
	           	    useStack( currentStackId );
	           }
	           
	           initializeSignIn();
	           if ( isGuest() ) {
		           if ( currentStackId < 0 ) {
		        	   clickMenu( selectedStudyActivity );
		           }
	           }
          }
          
      } );           
      
      
      //  see https://github.com/Tunts/WebIntent
      if ( window.plugins && window.plugins.webintent ) {
	      window.plugins.webintent.getExtra(window.plugins.webintent.EXTRA_TEXT, 
			function(url) {
		        console.log( 'webintent extra_text='+ url );
			}, function() {
    			console.log( 'no EXTRA_TEXT' );
			}
          );
	      window.plugins.webintent.getUri(function(url) {
		        console.log( 'webintent.getUri url='+ url + '<<<' );
	    	    if(url !== "") {
	    	    	// url is the url the intent was launched with
	    	    	window.openUrl = url ;
	    	    	handleOpenURL( url );
	    	    }
	    	});      
      }
      else {
          console.log( 'no window.plugins.webintent' );
      }
      
      addTapListener( $('#menuButton'), toggleMenu ) ;


      console.log( 'end of initializeApplication   openUrl = ' + openUrl );
   } // end initializeApplication






   function handleOrientationChange() {
       var menuItem = menuItems[selectedMenuItemIndex];
       if ( menuItem.onOrientationChange ) {
            menuItem.onOrientationChange();
       }
       if ( dPad ) {
       	    dPad.handleOrientationChange();
       }
	
   }


	   function handleDeviceBackButton( event ) {
        if ( isToastDisplayed() ) {
        	endToast();  
        }
        else if ( isLoginAreaDisplayed() ) {
            closeLoginArea();
        }
        else if ( isSignupAreaDisplayed() ) {
        	closeSignupArea();
        }
        else if ( isConnectWindowDisplayed() ) {
        	closeConnectWindow();
        }
    	else if( contextMenu.isVisible() ){
    		contextMenu.hide();
    	}
    	else if ( isMenuDisplayed() ) {
    	    hideMenu();
    	}
    	else {
	        event.preventDefault();
        	navigator.app.exitApp();
    	}
	}
	var currentStackId ;
	var studyStack = createStackFromJson( SAMPLE_SET );
	var  selectedMenuItemIndex = parseInt( dataManager.getLocalItem( 'selectedMenuItemIndex' ) );
	var selectedStudyActivity = dataManager.getLocalItem( 'selectedStudyActivity' );
	if ( selectedStudyActivity == null ) {
	    selectedStudyActivity = findMenuWithName( FLASHCARD_ACTIVITY );
	}
	console.log( 'selectedStudyActivity=' + selectedStudyActivity );
	  
	if ( !selectedMenuItemIndex || selectedMenuItemIndex <=0 ) {
		selectedMenuItemIndex = 1;
	}
	  
	console.log( 'selectedMenuItemIndex = ' + selectedMenuItemIndex );
	
	
	if ( !!window.cordova ) {
		document.addEventListener("deviceready", initializeApplication, false);
	    document.addEventListener("backbutton", handleDeviceBackButton, false );
		document.addEventListener("menubutton", showMenu, false);	   
	}
	else {
		initializeApplication();
	}
	   
	var sharePath = '' ;
	   
	function share() {
	    console.log( 'share()' );
	    console.log( 'window.plugins=' + window.plugins );
	    console.log( 'window.plugins.socialsharing=' + window.plugins.socialsharing );
	    if ( studyStack == null ) {
	        window.plugins.socialsharing.share(null, null, null, "https://www.studystack.com" );
	    }
	    else if ( studyStack.idOnStudyStack <= 0 ) {
	        toast( 'This set must be synchronized to studystack.com before it can be shared with others.', 6000 );
	    }
	    else {
	        window.plugins.socialsharing.share(null, null, null, "https://www.studystack.com" + sharePath );
	    }
	}
       
       
       
		function processOpenUrl( url ) {
		    console.log( 'processOpenUrl ' + url + ' initializationComplete=' + initializationComplete + ' window.openUrl=' + window.openUrl );
			if ( initializationComplete && url != null ) {
			     
			     var pos = url.indexOf( '/users/' ) ;
			     if ( pos > 0 ) {
			     	 processOpenUserUrl( url.substr( pos + '/users/'.length ) );
			     }
			     else {
			     	  pos = url.indexOf( '-' );
			     	  if ( pos > 0 ) {
			     	       processOpenStackUrl( url.substr( pos + 1 ) );
			     	  }
			     }
			     window.openUrl = null ; 
			}
		}
		
		function processOpenUserUrl( userName ) {
		     console.log( 'processOpenUserUrl userName=' + userName );
		     
		     // go to searchPage with user filled in and search started
		     searchPage.startUserSearch( userName );
		}
		
		function processOpenStackUrl( stackIdStr ) {
		    console.log( 'prcessOpenStackUrl stackIdStr=' + stackIdStr );
			var stackId = parseInt( stackIdStr );
			
  	  	    if ( stackId > 0 ) {
 	  	        // go to My Sets page with this set downloading...
				if ( syncService.syncOneSet( stackId ) ) {
					clickMenuWithName( MY_SETS );
				}
 	  	    }
		}
       
