console.log( 'matching.js' );

var matchingPreloadStatus ;
var tmpMatchImage ;
tmpMatchImage = document.getElementById( 'tmpMatchImage' );
tmpMatchImage.onload = function() { matchingPreloadStatus = 'loaded'; };
tmpMatchImage.onerror = function() { matchingPreloadStatus = 'error' ; };

var matchingPage = (function() {

        var matchingPageDiv ;
        var randomIndexes ;
        var nextIndex ;
        var MAX_MATCHES = 10;
        var questionOrder = [];
        var answerOrder = [];
        var questionSide = 0;
        var answerSide = 1;
        var firstClickedObj = null ;
        var numMatches ;
        var questionMatched;
        var answerMatched ;
        var allDisplayed ;
        

	function startPage() {
	   sharePath = '/picmatch-' + studyStack.idOnStudyStack ;
	   allDisplayed = false ;
	   
	   matchingPageDiv = document.getElementById( 'matchingPage' );
	   
	   dataManager.markMostRecentlyUsed( studyStack );

           contextMenu.setSetupFunc( setupContextMenu );
           nextIndex = 0;
           randomIndexes = createShuffledIntArray( studyStack.getNumCards()  ) ;
           if ( studyStack.getNumSides() < 2 ) {
                answerSide = 0;
           }
           initPuzzle();
	}
	
	function preloadBackground() {
		try {
			if ( matchingPreloadStatus == 'loaded' ) {
				matchingPageDiv.style.backgroundImage = "url('" + tmpMatchImage.src + "')";
			}
			else {
				matchingPageDiv.style.backgroundImage = "url( 'images/randomPic.png' )" ;	    
			}
			matchingPreloadStatus = 'loading' ;
			tmpMatchImage.src = 'http://www.studystack.com/randomPic.jsp?n=' + Math.floor( Math.random()* 1000 ) ;
		}
		catch ( err ) {
			console.log( 'err in preloadBackground' + err );
		}
	}


        function initPuzzle() {
           preloadBackground();
           numMatches = 0;
    	   questionMatched = [];
	       answerMatched = [];
           var shuffleNeeded = false ;
           for ( var i=0; i<MAX_MATCHES; i++ ) {
               var cardIndex = randomIndexes[ nextIndex ];

               questionOrder[ i ] = cardIndex ;
               answerOrder[ i ] = cardIndex ;

               nextIndex ++ ;
               if ( nextIndex >= studyStack.getNumCards() ) {
                   nextIndex = 0;
                   shuffleNeeded = true ;
             	   allDisplayed = true ;
               }
           }
           if ( shuffleNeeded ) {
               shuffle( randomIndexes );
           }
           shuffle( questionOrder );
           shuffle( answerOrder );
           updateUI();
        }


	function setupContextMenu() {
	    contextMenu.addMenuItem( "Start Over", true, startOver );
	}

	function startOver() {
	    initPuzzle();
	}
	
	
	
	function onOrientationChange() {
		updateUI();
	}
	
        function htmlForCell( isQuestion, index, cellClass ) {
            var text ;
	        var cls = 'matchingSquare ' + cellClass;
            var id ;
            if ( isQuestion ) {
                  text = studyStack.getCardSide( questionOrder[ index ], questionSide );
                  cls += ' matchingQuestion' ;
                  id = 'matchingSquare.Q.' + questionOrder[index] ;
                  if ( questionMatched[ questionOrder[index] ] ) {
                      cls +=  ' correctMatch'; 
                  }
            }
            else {
                  text = studyStack.getCardSide( answerOrder[ index ], answerSide );
                  cls += ' matchingAnswer' ;
                  id = 'matchingSquare.A.' + answerOrder[index] ;
                  if ( answerMatched[ answerOrder[index] ] ) {
                      cls +=  ' correctMatch'; 
                  }

            }
  	    return '<div id="' + id + '" class="' + cls + '"><div class="mcc">' + escapeHtml(text) + '</div></div>' ;
        }

        var busyProcessingSecondClick = false ;
        function matchClick( event ) {
            var obj = event.target.parentNode ;
            killEvent( event );
            if ( busyProcessingSecondClick ) {
            	return ;
            }
            
            if ( numMatches >= MAX_MATCHES ) {
		        startOver();
                return ;
            }
            $( obj ).addClass( 'matchingCell' );
            if ( firstClickedObj == null ) {
                 firstClickedObj = obj ;
            }
            else {
		 busyProcessingSecondClick = true ;            
                 if ( isMatch( firstClickedObj, obj ) ) {
	                 setTimeout( revealMatch, 200, firstClickedObj, obj ); 
                 }
                 else {
	                 setTimeout( clearMismatch, 500, firstClickedObj, obj );
                 }
            }
        }

        function isMatch( obj1, obj2 ) {
            var jqObj1 = $( obj1 );
            var jqObj2 = $( obj2 );
            var ndx1 = obj1.id.split( '.' )[2];
            var ndx2 = obj2.id.split( '.' )[2]; 
            var qa1 = obj1.id.split( '.' )[1];
            var qa2 = obj2.id.split( '.' )[1]; 

            if ( qa1 != qa2) {
                var question1 = studyStack.getCardSide(ndx1, questionSide);
                var question2 = studyStack.getCardSide(ndx2, questionSide);
		        var answer1 = studyStack.getCardSide(ndx1, answerSide);
		        var answer2 = studyStack.getCardSide(ndx2, answerSide);

                if ( (question1 == question2) || (answer1 == answer2) ) {
                    return true ;
                }
            }
            return false ;
        }
        
        
        function clearMismatch( obj1, obj2 ) {
            var jqObj1 = $( obj1 );
            var jqObj2 = $( obj2 );
            firstClickedObj = null ;
            console.log( 'firstClickedObj set to null in clearMismatch' );
            jqObj1.removeClass( 'matchingCell' );
            jqObj2.removeClass( 'matchingCell' );
            busyProcessingSecondClick = false ;
        }

        function revealMatch( obj1, obj2 ) {
            obj1.onclick = '' ;
            obj2.onclick = '' ;
			var jqObj1 = $( obj1 );
			var jqObj2 = $( obj2 );
			firstClickedObj = null ;
			jqObj1.removeClass( 'matchingCell' );
			jqObj2.removeClass( 'matchingCell' );
			var ndx1 = obj1.id.split( '.' )[2];
			var ndx2 = obj2.id.split( '.' )[2]; 
			var qa1 = obj1.id.split( '.' )[1];
			var qa2 = obj2.id.split( '.' )[1]; 
			
			var question1 = studyStack.getCardSide(ndx1, questionSide);
			var question2 = studyStack.getCardSide(ndx2, questionSide);
			var answer1 = studyStack.getCardSide(ndx1, answerSide);
			var answer2 = studyStack.getCardSide(ndx2, answerSide);

			numMatches ++ ;
			jqObj1.addClass( 'correctMatch' );
			jqObj2.addClass( 'correctMatch' );
			
			//kludge because sometimes the matchingCell color doesn't completely go away.
			jqObj1.hide().show(0);
			jqObj2.hide().show(0);
			
			if ( numMatches == MAX_MATCHES ) {
			    setTimeout( showPicture, 200 );
                if ( allDisplayed ) {
                    studyStack.finishActivity( MATCHING_CODE );
                }
                else {
                	setTimeout( continueMatching, 2000 );
                }
			}
			if ( qa1 == 'Q' ) {
			    questionMatched[ ndx1 ] = true ;
			    answerMatched[ ndx2 ] = true ;
			}
			else {
			    answerMatched[ ndx1 ] = true ;
			    questionMatched[ ndx2 ] = true ;
			}
            busyProcessingSecondClick = false ;
        }


        function showPicture() {
            $( '.matchingSquare' ).addClass( 'solvedPuzzle' ); 
            $( '.matchingSquare' ).fadeTo( 500, 0 );
            setTimeout( function() {
                 var matchGameDiv = document.getElementById( 'matchGame' );
                 matchGameDiv.innerHTML = '';
                 matchGameDiv.onclick=continueMatching; 
            }, 500 ); 
        }

    function continueMatching() {
        initPuzzle();
    }
    
	function updateUI() {
	    var row, col, i=0;
	    var html = '<div id="matchGame" >' ;
	    if ( isLandscape() ) {
	    	for ( row = 0; row<4; row++ ) {
	    	    for ( col = 0; col<5; col++ ) {
                        html += htmlForCell( row < 2, i%MAX_MATCHES, "match5w" );
	    	        i++;
	    	    }
	    	}     
	    }
	    else {
	    	for ( row = 0; row<5; row++ ) {
	    	    for ( col = 0; col<4; col++ ) {
                         html += htmlForCell( col<2, (col % 2)*5 + row, "match4w" ); 
	    	         i++;
	    	    }
	    	}     
	    }
	    html += '</div>';
	    matchingPageDiv.innerHTML = html ;
	    
	    $( '.matchingSquare' ).each( function() { 
	    	 addTapListener( $(this), matchClick ) ;	    	
	    } );
	    
	    if ( numMatches == MAX_MATCHES ) {
            $( '.matchingSquare' ).addClass( 'solvedPuzzle' ); 
            $( '.matchingSquare' ).fadeTo( 0, 0 ); 
        }
	    
	}
	
	
	
      return {
          startPage: startPage,
          onOrientationChange: onOrientationChange,
          matchClick: matchClick,
      } ;

})();

	





