console.log( 'mysets.js' );

var mysetsPage = (function() {

   var mySetsDiv ;
   var mySetsSortOrder = dataManager.getLocalItem(  "mySetsSortOrder" );
   var prevSortOrder = dataManager.getLocalItem( "prevSortOrder" );

   function startPage() {
       mySetsDiv = document.getElementById( 'mysetsList' );
	   
       setTitle( "My Sets" );

       contextMenu.setSetupFunc( setupContextMenu );
       refreshUI();
       dataManager.setChangeListener( mysetsPage );
       console.log( 'mysetsPage.startPage calling syncService.start( true )' );
       syncService.start( true );
    }


    function addStackToMySets( stack ){
            console.log( 'addStackToMySets ' + stack.id + ' ' + stack.name );
            var pie = pieHtml( stack );
            //mySetsDiv.innerHTML +=
            $( mySetsDiv ).append( 
                "<div class='mySetsStack'    onclick='useStack(" + stack.id + ");' style='background-color: " + colorCodes[ stack.color ] + "'   >" 
	         + "<div class='mySetsStackName'>" + escapeHtml( stack.name ) + "</div>"
	         + pie 
	         + "<img class='mySetsEdit' src='images/edit.png' onclick='mysetsPage.onEditClicked( event, " + stack.id + ")'/>"
	         + "<div class='mySetsStackInfo'>"
	         +       "Created: " + stack.createTime.split( ' ' )[0] + "<br />"
                 +       "Last used: " + ((stack.lastUsed==null) ? "Never" : (stack.lastUsed.split( ' ' )[0])) + "<br />"	                                     
	         +       "<span id='numCards." + stack.id + "'>" + stack.numCards +     ( (stack.numCards == 1) ? " card" : " cards" )  +   "</span>" 
	         + "</div>" 
	      + "</div>" 
              );
      }

    function onEditClicked( event, id ) {
        killEvent( event );
        editStack( id );
    }
    
    function addCreateStackToMySets(){
	         mySetsDiv.innerHTML += "<div id='mySetsCreateNew' class='mySetsStack'    onclick='clickMenuWithName( CREATE_NEW_SET )'    ><div id='mySetsPlus'>+</div><div id='addSetInstructions'>Create Set</div></div>" ;
      }

	     
    function refreshUI() {
         console.log( 'mysets.refreshUI' );
         mySetsDiv.innerHTML = '' ;
         var sortOrder = '' ;
         if ( mySetsSortOrder ) {
             sortOrder += 'ORDER BY ' + mySetsSortOrder ;
             if ( prevSortOrder && ( prevSortOrder != 'undefined' ) ) {
                 sortOrder += ', ' + prevSortOrder ;
             }
         }
	     dataManager.getStackList( sortOrder, addStackToMySets, addCreateStackToMySets);
	     console.log( 'after dataManager.getStackList-----------------------------' );
	     refreshConnectionStatusMessage();
    }
    
    document.addEventListener("online", refreshConnectionStatusMessage, false);
    document.addEventListener("offline", refreshConnectionStatusMessage, false);

    
    function refreshConnectionStatusMessage() {
         var mysetsBottom = document.getElementById( 'mysetsBottom' ) ;
         if ( mysetsBottom ) {
	         if ( !hasNetworkConnection() ) {
	            mysetsBottom.innerHTML = 'Enable WIFI/Data connection to sync with studystack.com' ;
	         } 	         
	         else if ( isGuest() ) {
	            mysetsBottom.innerHTML = 'Login to sync with studystack.com<br />' 
	                                     + '<button class="actionButton" onclick="mysetsPage.openConnectWindow()">Login</button>' ; 
	         }
	         else {
	            mysetsBottom.innerHTML = '' ;
	         }
         }
    }
    
    function openConnectWindow() {
         showConnectWindow( handleLogin );
    }
    
    function handleLogin() {
         console.log( 'mysets.handleLogin calling syncService.start( true )' );
         syncService.start( true );
         refreshUI();
    }

	function setupContextMenu() {
	    contextMenu.addMenuItem( "Sort by set's name", true, sortByName );
	    contextMenu.addMenuItem( "Sort by date created", true, sortByDateCreated );
	    contextMenu.addMenuItem( "Sort by date used", true, sortByDateUsed );
	    contextMenu.addMenuItem( "Sort by color", true, sortByColor );
	    var connected = hasNetworkConnection();
	    contextMenu.addMenuItem( "Refresh", connected, refresh );
	    if ( isGuest() ) {
	        contextMenu.addMenuItem( "Login", connected, mysetsPage.openConnectWindow ); 
	    }
	    else {
	         contextMenu.addMenuItem( "Logout", true, mysetsPage.logout );
	    }
	}
	
	function refresh() {
	    syncService.start( true );
            refreshUI();
	}
	
	function sortByColor() {
	   setSortOrder( ORDER_BY_COLOR );
	}
	
	function sortByName() {
	    setSortOrder( ORDER_BY_NAME );
	}
	
	function sortByDateCreated() {
	     setSortOrder( ORDER_BY_DATE_CREATED );
	}
	
	function sortByDateUsed() {
	     setSortOrder( ORDER_BY_DATE_USED );
	}
	
	function setSortOrder( newOrder ) {
	    if ( newOrder == mySetsSortOrder ) {
	        return ;
	    }
	    prevSortOrder = mySetsSortOrder ;
	    mySetsSortOrder = newOrder ; 
	    dataManager.setLocalItem( "mySetsSortOrder", mySetsSortOrder );
	    dataManager.setLocalItem( "prevSortOrder", prevSortOrder );
	    refreshUI();
	}


	function stackAdded( id, name ) {
	    dataManager.getStackInfo( id, function( stack ) {
	        var createNewDiv = document.getElementById( 'mySetsCreateNew');
	        if ( createNewDiv ) {
	        	createNewDiv.parentNode.removeChild(createNewDiv);
	    		addStackToMySets( stack );
				addCreateStackToMySets();
			}
	    } );
	}
	
    var numCardsSpan = null;	
	function cardAdded( id, numCards ) {
	    var spanId = 'numCards.' + id ;
	    if ( numCardsSpan == null || numCardsSpan.id != spanId ) {
	        numCardsSpan = document.getElementById( spanId );
	    }
	    if ( numCardsSpan != null ) {
	        numCardsSpan.innerHTML = numCards + ( (numCards == 1) ? " card" : " cards" );
	    }
	}
	
	function logout() {
	     continueAsGuest();
	     refreshUI();
	}
	
      return {
          onEditClicked: onEditClicked,
          startPage: startPage,
          openConnectWindow: openConnectWindow,
          cardAdded: cardAdded,
          stackAdded: stackAdded,
          logout: logout,
      } ;

})();

	
