console.log( 'utils.js' );

var LEFT_ARROW_KEY = 37;
var UP_ARROW_KEY = 38;
var RIGHT_ARROW_KEY = 39;
var DOWN_ARROW_KEY = 40;
var BACKSPACE_KEY = 8;
var ENTER_KEY = 13 ;

var C_KEY = 67;
var H_KEY = 72;
var I_KEY = 73;
var J_KEY = 74;
var K_KEY = 75;
var L_KEY = 76;
var R_KEY = 82;
var W_KEY = 87;
var SEMICOLON_KEY = 186;


function escapeHtml( str ) {
   return str.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');
}

function createShuffledIntArray( size ) {
    var array = [];
    for ( var i=0; i<size; i++ ) {
         array[i] = i;
    }
    return shuffle( array );   
}

function randomInteger( min, max ) {
      return Math.floor( Math.random() * (max-min)) + min ;
 }


function shuffle(o) {
    for(var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
    return o;
};

function killEvent( event ) {
    if ( !event ) {
        return ;
    }
    if(event.preventDefault){
         event.preventDefault();
    }
    if (event.stopPropagation) {
        event.stopPropagation();
    } 
}


    
var punctuation = ".,|();: <>[]{}!@#$%^&*_-+=~`/?'0123456789";
 
function removePunctuation( word ) {
   var retVal = "" ;
   var i;
   
   for ( i = 0; i< word.length; i++ ) {
      letter = word.charAt( i );
      if ( punctuation.indexOf( letter ) < 0 ) {
          retVal += letter ;
      }
   }
   return retVal ;
}


       function getProps( obj ) {
          var propList = '';
          for ( var props in obj ) {
              propList += (props + "=" + obj[props] + " " );
          }
          return propList ;
       }

       function dumpProps( obj ) {
          alert( getProps( obj ) );
       }

    
   var toastQueue = new Array();
   var toastTimer = null ;
      
   function toast( message, milliseconds ) {
        if ( !milliseconds ) {
            milliseconds = 5000;
        }
        toastQueue.push( { message: message, milliseconds: milliseconds } ) ;
        if ( toastTimer == null ) {
            // endToast will show toast
            endToast();
        }
   }
   
   function endToast() {
        var nextToast = toastQueue.shift();
        var toastDiv = document.getElementById( 'toastDiv' );
        var toastWrapper = document.getElementById( 'toastWrapper' );
        if ( nextToast == null ) {
             toastWrapper.style.display = 'none' ;
             toastTimer = null ;
        }
        else {
             toastDiv.innerHTML = nextToast.message ;
             toastWrapper.style.display = 'block' ;
             toastTimer = setTimeout( endToast, nextToast.milliseconds );
        }
   }
   
   function isToastDisplayed() {
        return toastTimer != null ;
   }
   
   function hasNetworkConnection() {
       try {
          var networkState = navigator.connection.type;
          return networkState != Connection.NONE ;
	   }
	   catch(err) {
	       console.log( 'hasNetworkConnection caught error: ' + err );
	       return true ;
	   }	       
   }

   function isLandscape() {
       return $( window ).width() > $( window ).height(); 
   }

   function stringifyNumArray( numArray ) {
      var prevLastIndex = numArray.length - 2;
      var str = '' ;
      for ( var i=0; i<=prevLastIndex; i++ ) {
          str += (numArray[i] + ',' );
      }
      var lastIndex = prevLastIndex + 1;
      if ( lastIndex >= 0 ) {
          str += numArray[ lastIndex ];
      }
      return str ;
   }
   
   function downloadImage() {
      var url = 'http://www.studystack.com/orderedPic.jsp?n=17';
      window.requestFileSystem(PERSISTENT, 0, function (fs) {
          var imagePath = fs.root.fullPath + "/logo.png"; // full file path
          console.log( 'imagePath=' + imagePath );
          var fileTransfer = new FileTransfer();
          fileTransfer.download(url, imagePath, 
              function (entry) {
                  console.log( 'success.   ' + entry.fullPath); // entry is fileEntry object
              }, 
              function (error) {
                  console.log( "Some error:" + error);
              });
      });
      
   }

   function vibrate( milliseconds ) {
	   if ( navigator && navigator.vibrate ) {
		    navigator.vibrate( milliseconds );
	   }
	   else if ( navigator && navigator.notification && navigator.notification.vibrate ) {   
		    navigator.notification.vibrate( milliseconds );
	   }
   }
   

   function beep() {
     playMP3( 'nicebeep.mp3' );
   }

   function playCorrect() {
	   playMP3( 'correct.mp3' );
   }
   
   function playWrong() {
	   playMP3( 'wrong.mp3' );
   }
 
   function playMP3( file ) {
	if ( (typeof device != 'undefined') && (device.platform == 'Android') ) {
		file = '/android_asset/www/' + file ;
	} 
	if (typeof Media != 'undefined') {
		new Media( file ).play();
	}
	else {
	     	var audio = document.createElement('audio');
		audio.src = file;
		audio.play();
	}
   }
   
  function logDebugInfo() {
	  console.log( '----------------------------------- logDebugInfo ---------------------------');
	  if ( typeof device != 'undefined' ) {
		      console.log( 'device.platform:' + device.platform );
	  }
	  else {
		  console.log( 'device is undefined' );
	  }
	  
      try {
          var networkState = navigator.connection.type;
          console.log( 'networkState is ' + networkState );
	   }
	   catch(err) {
	       console.log( 'hasNetworkConnection caught error: ' + err );
	   }	       
	   
       console.log( 'Media is ' + typeof Media  );
	   console.log( 'typeof TTS is ' + typeof TTS );
	   console.log( 'typeof SpeechSynthesisUtterance is ' + typeof SpeechSynthesisUtterance );
  } 
   
  function addTapListener( jqobj, listener ) {
      var domObj = jqobj[0];
      var wrappedListener = function( event ) {
        killEvent( event );
        listener( event );
      }
      domObj.addEventListener('touchstart', wrappedListener );
      domObj.addEventListener( 'mousedown', wrappedListener );
      //jqobj.click( listener );
  }
   
  function addTapReleaseListener( jqobj, listener ) {
      var domObj = jqobj[0];
      var wrappedListener = function( event ) {
        killEvent( event );
        listener( event );
      }
      domObj.addEventListener('touchend', wrappedListener );
      domObj.addEventListener( 'mouseup', wrappedListener );
      //jqobj.click( listener );
  }
  
  
  function addRemoveClass( obj, add, className ) {
	    if ( add ) {
	   	    $( obj ).addClass( className ) ;
	    }
	    else {
	   	    $( obj ).removeClass( className ) ;
	    }
	}


   
     function svgPieSlice( color ) {
         var radius = 15;
         var html = '<svg height="' + radius*2 + '" width="' + radius*2 + '">' ;
         
         var startAngle = -30;
         var endAngle = startAngle + 60 ;
         var center = 10;

         x1 = parseInt(0.5 + center + radius*Math.cos(Math.PI*startAngle/180.0));
         y1 = parseInt(0.5 + center + radius*Math.sin(Math.PI*startAngle/180.0));

         x2 = parseInt(0.5 + center + radius*Math.cos(Math.PI*endAngle/180.0));
         y2 = parseInt(0.5 + center + radius*Math.sin(Math.PI*endAngle/180.0));                

         var d = "M" + center + "," + center + "  L" + x1 + "," + y1 + "  A" + radius + "," + radius + " 0 0,1 " + x2 + "," + y2 + " z"; 
         html += '<path d="' + d + '" fill="' + color + '"  stroke="black" stroke-width="1" stroke-linejoin="round"    />' ;
         
         html += '</svg>';

         
         
         
    	 return html ;
     }
     
     function svgDonut( radius, innerRadius, padding, percent, color, bgColor, innerColor ){
            var startAngle = 0;
            var x1,x2,y1,y2 = 0;
            var length = radius*2 + padding ;
            var center = length / 2;
            var endAngle ;
            var angle ;
            var text = Math.floor( percent * 100 + 0.5 ) ;
            if ( isNaN( text ) ) {
            	text = 'No Cards' ;
            }
            var percentText = '<text fill="black" text-anchor="middle" alignment-baseline="middle" x="' + center + '" y="' + center + '">' + text + '%</text>' ;
            if ( percent > 0.5 ) {
            	percent = 1 - percent ;
            	angle = Math.ceil(360 * percent );
            	endAngle = 270 - angle ;
            	var tmp = bgColor ;
            	bgColor = color ;
            	color = tmp ;
            }
            else {
                endAngle = 270 ;
            	angle = Math.ceil(360 * percent );
            }

            var html = '<svg height="' + length + '" width="' + length + '">' ;

            html += '<circle cx="' + center + '" cy="' + center + '" r="' + (radius) + '"fill="' + bgColor + '" />';

            startAngle = endAngle;
            endAngle = startAngle + angle ;

            x1 = parseInt(0.5 + center + radius*Math.cos(Math.PI*startAngle/180.0));
            y1 = parseInt(0.5 + center + radius*Math.sin(Math.PI*startAngle/180.0));

            x2 = parseInt(0.5 + center + radius*Math.cos(Math.PI*endAngle/180.0));
            y2 = parseInt(0.5 + center + radius*Math.sin(Math.PI*endAngle/180.0));                

            var d = "M" + center + "," + center + "  L" + x1 + "," + y1 + "  A" + radius + "," + radius + " 0 0,1 " + x2 + "," + y2 + " z"; 
            html += '<path d="' + d + '" fill="' + color + '"/>' ;
            html += '<circle cx="' + center + '" cy="' + center + '" r="' + (innerRadius) + '"fill="' + innerColor + '" />';
            html += percentText ;
            html += '</svg>';
            return html ;
        }   
   
   
   
   
   
   
   
   
   
if (typeof String.prototype.startsWith != 'function') {
  String.prototype.startsWith = function (str){
    return this.slice(0, str.length) == str;
  };
}   



