console.log( 'webservices.js' );

var NO_ERROR = 0;
var BAD_LOGIN = -1;
var SERVER_ERROR = -2;
var NO_USERS = -3;
var INVALID_EMAIL = -4;
var MISSING_EMAIL = -5;
var USERNAME_TAKEN = -6;

var webService = (function() {

	function serverCommand( serverPath, settings ) {
	    console.error( 'serverCommand: ' + serverPath );
	    //$.ajax( "http://68.169.62.12" + serverPath, settings );        // test.studystack.com
	    $.ajax( "https://www.studystack.com" + serverPath, settings );
	} 


    function getUpdatedSets( idList, modTimeList, callback, errorHandler ) {
	   serverCommand( "/ajaxGetUpdatedSets.jsp", 
	         { 
	           dataType: "text",
	           data: { idList: idList,
	                   modTimeList: modTimeList,
	                   user: userId,
	                   token: accessToken }, 
	           cache : false,
	           success: function( data, textStatus, jqXHR ) {
	                  console.log( 'studystack.com response for getUpdatedSets is ' + data );
	                  var idArray ;
	                  var isPro = false ;
	                  var data = data.trim();
	                  if ( data.length == 0 ) {
	                      idArray = [];
	                  }
	                  else {
	                      idArray = data.split( "," );
	                      isPro = (idArray.shift() == 1);  
	                  }
	                  dataManager.setLocalItem( "pro", isPro );
	                  callback( idArray );
	               },
	           error: function(jqXHR, textStatus, errorThrown){
	                  console.log( 'studystack.com returned error ' + errorThrown + ' for getUpdatedSets.'  );
	                  errorHandler( jqXHR, textStatus, errorThrown );
	               }
	         } 
	      );
    }

    function getStudyStack( id, callback ) {
    	// http://www.studystack.com/servlet/json?studyStackId=1&strict=Y&appId=pgStudyStack&includeCardIds=Y&userId=1
    	serverCommand( "/servlet/json",
    		{
	           dataType: "json",
	           data: { studyStackId: id,
	                   strict: 'Y',
	                   includeCardIds: 'Y',
	                   appId: 'pgStudyStack',
	                   user: userId,
	                   token: accessToken }, 
	           cache : false,
	           success: function( data, textStatus, jqXHR ) {
	           	     callback( data );
	               },
	           error: function(jqXHR, textStatus, errorThrown){
	                 console.error( 'getStudyStack for ' + id + ' failed.  textStatus=' + textStatus + ' errorThrown=' + errorThrown );
	                 callback( null ); 
	               }
    		}
    	);
    }
    



    function updateDirtyParts( studyStack, callback ) {
    	serverCommand( "/servlet/changeImporter/?x=1",
    		{
	           dataType: "json",
	           type: "POST",
	           data: { stackJson: studyStack.getDirtyJson(),
	                   appId: 'pgStudyStack',
	                   user: userId,
	                   token: accessToken }, 
	           cache : false,
	           contentType: "application/x-www-form-urlencoded;charset=utf-8",
	           success: function( data, textStatus, jqXHR ) {
	           	     callback( data );
	               },
	           error: function(jqXHR, textStatus, errorThrown){
	                 console.error( 'updateDirtyParts for ' + studyStack.id + ' failed.  textStatus=' + textStatus + ' errorThrown=' + errorThrown );
	                 callback( null ); 
	               }
    		}
    	);
    }


     
	
	function resetPassword( userNameOrEmail, callback ) {
	   
	   serverCommand( "/ajaxForgotPassword.jsp", 
	         { 
	           dataType: "text",
	           data: { info: userNameOrEmail }, 
	           cache : false,
	           success: function( data, textStatus, jqXHR ) {
	                  console.log( 'ajaxForgotPassword success' );
	                  if ( data == null ) {
	                      callback( SERVER_ERROR );
		              }
		              else if ( data.indexOf( "EMAILSENT" ) >= 0 ) {
		              	  callback( NO_ERROR );
	                  }
	                  else if ( data.indexOf( "NO_USERS" ) >= 0 ) {
	                  	  callback( NO_USERS );
	                  }
	                  else if ( data.indexOf( "INVALID_EMAIL" ) >= 0 ) {
	                  	  callback( INVALID_EMAIL );
	                  }
	                  else if ( data.indexOf( "MISSING_EMAIL" ) >= 0 ) {
	                  	  callback( MISSING_EMAIL );
	                  }
	                  else {
	                  	  callback( SERVER_ERROR );
	                  }
	               },
	           error: function(jqXHR, textStatus, errorThrown){
  	                      console.log( 'ajaxForgotPassword error' );
	                      callback( SERVER_ERROR );
	               }
	         } 
	      );
	}
	
    
    
	function signIn( userName, password, callback ) {
	   serverCommand( "/ajaxSignIn.jsp", 
	         { 
	           dataType: "text",
	           data: { i: userName,
	                   p: password },
	           cache : false,
	           success: function( data, textStatus, jqXHR ) {
	                      data = data.trim();
	                      var parts = data.split( ' ' );
	                      if ( parts.length >=2 ) {
	                          var id = parts[0].trim();
	                          var token = parts[1].trim();
	                          callback( NO_ERROR, id, token );
	                      }
	                      else {
	                          console.log( 'parts.length=' + parts.length );
	                          callback( BAD_LOGIN );
	                      }
	               },
	           error: function(jqXHR, textStatus, errorThrown){
	                      console.log( 'jqXHR=' + jqXHR );
	                      console.log( 'jqXHR=' + getProps( jqXHR ) );
	                      console.log( 'textStatus=' + textStatus );
	                      console.log( 'errorThrown=' + errorThrown );
	                      console.log( 'errorThrown=' + getProps( errorThrown )) ;
	                      callback( SERVER_ERROR );
	               }
	         } 
	      );
	}

	function createAccount( userName, password, emailAddress, callback ) {
	   serverCommand( "/ajaxCreateAccount.jsp", 
	         { 
	           dataType: "text",
	           data: { i: userName,
	                   p: password,
	                   e: emailAddress },
	           cache : false,
	           success: function( data, textStatus, jqXHR ) {
	                      data = data.trim();
	                      var parts = data.split( ' ' );
	                      if ( parts.length >=2 ) {
	                          var id = parts[0].trim();
	                          var token = parts[1].trim();
	                          callback( NO_ERROR, id, token );
	                      }
	                      else {
	                          callback( BAD_LOGIN );
	                      }
	               },
	           error: function(jqXHR, textStatus, errorThrown){
	           			if ( jqXHR.status == 409 ) {
	           			    callback( USERNAME_TAKEN );
	           			}
	           			else if ( jqXHR.status == 404 ) {
	           			     callback( INVALID_EMAIL ); 
	           			}
	                    else {
	                         callback( SERVER_ERROR );
	                    }
	               }
	         } 
	      );
	}

	
    function doSearch( userName, query, categoryId, size, page, callback ) {
    	// http://www.studystack.com/SearchSets.jsp?q=fish&size=5&page=1&ff=category|Biology&appId=PhGa7210
    	var categoryQuery = (categoryId < 0) ? '' : ('category|' + getCategory( categoryId ).name) ;
    	var userQuery = (userName == '') ? '' : ('?ff=username2|' + userName);
    	serverCommand( "/SearchSets.jsp" + userQuery,
    		{
	           dataType: "json",
	           data: { q: query,
	                   ff: categoryQuery,
	                   size: size,
	                   page: page,
	                   appId: 'pgStudyStack' }, 
	           cache : false,
	           success: function( data, textStatus, jqXHR ) {
	           	     callback( data );
	               },
	           error: function(jqXHR, textStatus, errorThrown){
	                 console.error( 'doSearch failed.  textStatus=' + textStatus + ' errorThrown=' + errorThrown );
	                 callback( null ); 
	               }
    		}
    	);
    }

    
    return {
          createAccount: createAccount,
          doSearch: doSearch,
          getStudyStack: getStudyStack,
          getUpdatedSets: getUpdatedSets,
          resetPassword: resetPassword,
          signIn: signIn,
          updateDirtyParts: updateDirtyParts,
    } ;
    
    

})();

	